NDD = {...}

local _InitAddon, _InitGUI, _RegisterEvents

local loadingFrame = CreateFrame("Frame", nil, UIParent)
loadingFrame:RegisterEvent("ADDON_LOADED")
loadingFrame:RegisterEvent("PLAYER_LOGIN")

loadingFrame:SetScript("OnEvent", function(self, event, arg1, ...)

    if event == "ADDON_LOADED" then
        _InitAddon()
    end

    if event == "PLAYER_LOGIN" then
        _InitGUI()
    end
end)

NDD.loadingFrame = loadingFrame

_InitAddon = function() 
    if (not NDDConfig) then
        NDDConfig = {}
    end

    local nddc = NDDConfig;

    if (nddc.showpartymessage == nil) then
        NDDConfig.showpartymessage = false
    end
    
    if (nddc.healthAlertSound == nil) then
        NDDConfig.healthAlertSound = "nigeldontdie.ogg"
    end

    if (nddc.healthThresholdPercent == nil) then
        NDDConfig.healthThresholdPercent = 0.3
    end
end

_InitGUI = function() 
    local eventFrame = CreateFrame("Frame", nil, UIParent)
    _RegisterEvents(eventFrame)
    eventFrame:SetScript("OnEvent", function(self,event,...)
        local health = UnitHealth("player",0)
        local maxHealth = UnitHealthMax("player",0)
        local lowHealthMessage = "NIGEL DON'T DIE!"
    
        if maxHealth == nil or maxHealth == 0 then
            do return end
        end
    
        if (health/maxHealth) <= NDDConfig.healthThresholdPercent and not alertThrottled then
            PlaySoundFile("Interface/AddOns/NigelDontDie/sounds/" .. NDDConfig.healthAlertSound, "Master")
            
            if NDDConfig.showpartymessage then
                SendChatMessage(lowHealthMessage)
            end
    
            alertThrottled = true
        elseif (health/maxHealth) > NDDConfig.healthThresholdPercent then
            alertThrottled = false
        end
    end)
end

_RegisterEvents = function (eventFrame)
    eventFrame:RegisterEvent("UNIT_HEALTH")
end