local AceConfig = LibStub("AceConfig-3.0")
local AceGUI = LibStub("AceGUI-3.0")

local alertSounds = {
    ["nigeldontdie.ogg"] = "Nigel Don't Die!",
    ["alarmbuzzer.ogg"] = "Standard alert"
}

local options = {
    name = "Nigel Don't Die!",
    handler = NDD,
    type = 'group',
    args = {
        showpartymessage = {
            type = 'toggle',
            name = 'Enable chat alerts ',
            desc = 'Call out for aid in instances',
            set = 'SetEnableChatAlerts',
            get = 'GetEnableChatAlerts',
            order = 0
        },
        healthAlertSound = {
            type = 'select',
            name = 'Select Sound',
            desc = 'The Sound to play when health is low.',
            values = alertSounds,
            set = 'SetLowHealthSound',
            get = 'GetLowHealthSound',
            order = 1
        },
        healthThresholdPercent = {
            type = 'range',
            name = 'Set Health % Threshold',
            desc = "Sets the percentage of health left of overall to play sound.",
            min = 0.0, 
            max = 1.0,
            step = 0.01,
            isPercent = true,
            get = 'GetHealthPercentThreshold',
            set = 'SetHealthPercentThreshold',
            order = 2
        }
    },
}

function NDD:GetEnableChatAlerts(info)
    return NDDConfig.showpartymessage; 
end

function NDD:SetEnableChatAlerts(info, toggle)
    if toggle == nil then
        NDDConfig.showpartymessage = false
    else
        NDDConfig.showpartymessage = toggle 
    end
end

function NDD:GetLowHealthSound(info)
    return NDDConfig.healthAlertSound
end

function NDD:SetLowHealthSound(info, value)
    NDDConfig.healthAlertSound = value
end

function NDD:GetHealthPercentThreshold(info)
    return NDDConfig.healthThresholdPercent
end

function NDD:SetHealthPercentThreshold(info, value)
    NDDConfig.healthThresholdPercent = value
end

LibStub("AceConfig-3.0"):RegisterOptionsTable("NDD", options, {"NDD"})
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("NDD", "Nigel don't die!")